## GtkMessageDialog

GtkMessageDialog — A convenient message window

## Functions

GtkWidget * | gtk_message_dialog_new ()
GtkWidget * | gtk_message_dialog_new_with_markup ()
void | gtk_message_dialog_set_markup ()
void | gtk_message_dialog_set_image ()
GtkWidget * | gtk_message_dialog_get_image ()
GtkWidget * | gtk_message_dialog_get_message_area ()
void | gtk_message_dialog_format_secondary_text ()
void | gtk_message_dialog_format_secondary_markup ()

## Properties

GtkButtonsType | buttons | Write / Construct Only
GtkWidget * | image | Read / Write
GtkWidget * | message-area | Read
GtkMessageType | message-type | Read / Write / Construct
gchar * | secondary-text | Read / Write
gboolean | secondary-use-markup | Read / Write
gchar * | text | Read / Write
gboolean | use-markup | Read / Write

## Style Properties

gint | message-border | Read
gboolean | use-separator | Read

## Types and Values

struct | GtkMessageDialog
enum | GtkMessageType
enum | GtkButtonsType

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkBin
                            ╰── GtkWindow
                                ╰── GtkDialog
                                    ╰── GtkMessageDialog

## Implemented Interfaces

GtkMessageDialog implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkMessageDialog presents a dialog with an image representing the type of message (Error, Question, etc.) alongside some message text. It's simply a convenience widget; you could construct the equivalent of GtkMessageDialog from GtkDialog without too much effort, but GtkMessageDialog saves typing.

The easiest way to do a modal message dialog is to use `gtk_dialog_run()`, though you can also pass in the `GTK_DIALOG_MODAL` flag, `gtk_dialog_run()` automatically makes the dialog modal and waits for the user to respond to it. `gtk_dialog_run()` returns when any dialog button is clicked.

Example 8. A modal dialog.

    1
    2
    3
    4
    5
    6
    7
    8

    dialog = gtk_message_dialog_new (main_application_window,
                                     GTK_DIALOG_DESTROY_WITH_PARENT,
                                     GTK_MESSAGE_ERROR,
                                     GTK_BUTTONS_CLOSE,
                                     "Error loading file '%s': %s",
                                     filename, g_strerror (errno));
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);

You might do a non-modal GtkMessageDialog as follows:

Example 9. A non-modal dialog.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11

    dialog = gtk_message_dialog_new (main_application_window,
                                     GTK_DIALOG_DESTROY_WITH_PARENT,
                                     GTK_MESSAGE_ERROR,
                                     GTK_BUTTONS_CLOSE,
                                     "Error loading file '%s': %s",
                                     filename, g_strerror (errno));

    /* Destroy the dialog when the user responds to it (e.g. clicks a button) */
    g_signal_connect_swapped (dialog, "response",
                              G_CALLBACK (gtk_widget_destroy),
                              dialog);

### GtkMessageDialog as GtkBuildable

The GtkMessageDialog implementation of the GtkBuildable interface exposes the message area as an internal child with the name "message_area".

## Functions

### gtk_message_dialog_new ()

    GtkWidget *
    gtk_message_dialog_new (GtkWindow *parent,
                            GtkDialogFlags flags,
                            GtkMessageType type,
                            GtkButtonsType buttons,
                            const gchar *message_format,
                            ...);

Creates a new message dialog, which is a simple dialog with an icon indicating the dialog type (error, warning, etc.) and some text the user may want to see. When the user clicks a button a "response" signal is emitted with response IDs from GtkResponseType. See GtkDialog for more details.

#### Parameters

parent | transient parent, or `NULL` for none. | [allow-none]
flags | flags |
type | type of message |
buttons | set of buttons to use |
message_format | `printf()`-style format string, or `NULL`. | [allow-none]

#### Returns

a new GtkMessageDialog.

[transfer none]

### gtk_message_dialog_new_with_markup ()

    GtkWidget *
    gtk_message_dialog_new_with_markup (GtkWindow *parent,
                                        GtkDialogFlags flags,
                                        GtkMessageType type,
                                        GtkButtonsType buttons,
                                        const gchar *message_format,
                                        ...);

Creates a new message dialog, which is a simple dialog with an icon indicating the dialog type (error, warning, etc.) and some text which is marked up with the Pango text markup language. When the user clicks a button a "response" signal is emitted with response IDs from GtkResponseType. See GtkDialog for more details.

Special XML characters in the `printf()` arguments passed to this function will automatically be escaped as necessary. (See `g_markup_printf_escaped()` for how this is implemented.) Usually this is what you want, but if you have an existing Pango markup string that you want to use literally as the label, then you need to use `gtk_message_dialog_set_markup()` instead, since you can't pass the markup string either as the format (it might contain '%' characters) or as a string argument.

    1
    2
    3
    4
    5
    6
    7
    8

    GtkWidget *dialog;
    dialog = gtk_message_dialog_new (main_application_window,
                                     GTK_DIALOG_DESTROY_WITH_PARENT,
                                     GTK_MESSAGE_ERROR,
                                     GTK_BUTTONS_CLOSE,
                                     NULL);
    gtk_message_dialog_set_markup (GTK_MESSAGE_DIALOG (dialog),
                                   markup);

#### Parameters

parent | transient parent, or `NULL` for none. | [allow-none]
flags | flags |
type | type of message |
buttons | set of buttons to use |
message_format | `printf()`-style format string, or `NULL`. | [allow-none]

#### Returns

a new GtkMessageDialog

Since 2.4

### gtk_message_dialog_set_markup ()

    void
    gtk_message_dialog_set_markup (GtkMessageDialog *message_dialog,
                                   const gchar *str);

Sets the text of the message dialog to be `str` , which is marked up with the Pango text markup language.

#### Parameters

message_dialog | a GtkMessageDialog |
str | markup string (see Pango markup format) |

Since 2.4

### gtk_message_dialog_set_image ()

    void
    gtk_message_dialog_set_image (GtkMessageDialog *dialog,
                                  GtkWidget *image);

Sets the dialog's image to `image` .

#### Parameters

dialog | a GtkMessageDialog |
image | the image |

Since 2.10

### gtk_message_dialog_get_image ()

    GtkWidget *
    gtk_message_dialog_get_image (GtkMessageDialog *dialog);

Gets the dialog's image.

#### Parameters

dialog | a GtkMessageDialog |

#### Returns

the dialog's image.

[transfer none]

Since 2.14

### gtk_message_dialog_get_message_area ()

    GtkWidget *
    gtk_message_dialog_get_message_area (GtkMessageDialog *message_dialog);

Returns the message area of the dialog. This is the box where the dialog's primary and secondary labels are packed. You can add your own extra content to that box and it will appear below those labels, on the right side of the dialog's image (or on the left for right-to-left languages). See `gtk_dialog_get_content_area()` for the corresponding function in the parent GtkDialog.

#### Parameters

message_dialog | a GtkMessageDialog |

#### Returns

A GtkVBox corresponding to the "message area" in the `message_dialog` .

[transfer none]

Since 2.22

### gtk_message_dialog_format_secondary_text ()

    void
    gtk_message_dialog_format_secondary_text
                                   (GtkMessageDialog *message_dialog,
                                    const gchar *message_format,
                                    ...);

Sets the secondary text of the message dialog to be `message_format` (with `printf()`-style).

Note that setting a secondary text makes the primary text become bold, unless you have provided explicit markup.

#### Parameters

message_dialog | a GtkMessageDialog |
message_format | `printf()`-style format string, or `NULL`. | [allow-none]

Since 2.6

### gtk_message_dialog_format_secondary_markup ()

    void
    gtk_message_dialog_format_secondary_markup
                                   (GtkMessageDialog *message_dialog,
                                    const gchar *message_format,
                                    ...);

Sets the secondary text of the message dialog to be `message_format` (with `printf()`-style), which is marked up with the

Pango text markup language.

Note that setting a secondary text makes the primary text become bold, unless you have provided explicit markup.

Due to an oversight, this function does not escape special XML characters like `gtk_message_dialog_new_with_markup()` does. Thus, if the arguments may contain special XML characters, you should use `g_markup_printf_escaped()` to escape it.

    1
    2
    3
    4
    5

    gchar *msg;

    msg = g_markup_printf_escaped (message_format, ...);
    gtk_message_dialog_format_secondary_markup (message_dialog, "%s", msg);
    g_free (msg);

#### Parameters

message_dialog | a GtkMessageDialog |
message_format | printf()-style markup string (see Pango markup format), or `NULL` |

Since 2.6

## Types and Values

### struct GtkMessageDialog

    struct GtkMessageDialog;

### enum GtkMessageType

The type of message being displayed in the dialog.

#### Members

GTK_MESSAGE_INFO | Informational message |
GTK_MESSAGE_WARNING | Nonfatal warning message |
GTK_MESSAGE_QUESTION | Question requiring a choice |
GTK_MESSAGE_ERROR | Fatal error message |
GTK_MESSAGE_OTHER | None of the above, doesn't get an icon |

### enum GtkButtonsType

Prebuilt sets of buttons for the dialog. If none of these choices are appropriate, simply use `GTK_BUTTONS_NONE` then call `gtk_dialog_add_buttons()`.

Please note that `GTK_BUTTONS_OK`, `GTK_BUTTONS_YES_NO` and `GTK_BUTTONS_OK_CANCEL` are discouraged by the GNOME HIG.

#### Members

GTK_BUTTONS_NONE | no buttons at all |
GTK_BUTTONS_OK | an OK button |
GTK_BUTTONS_CLOSE | a Close button |
GTK_BUTTONS_CANCEL | a Cancel button |
GTK_BUTTONS_YES_NO | Yes and No buttons |
GTK_BUTTONS_OK_CANCEL | OK and Cancel buttons |

## Property Details

### The `“buttons”` property

      “buttons”                  GtkButtonsType

The buttons shown in the message dialog.

Flags: Write / Construct Only

Default value: GTK_BUTTONS_NONE

### The `“image”` property

      “image”                    GtkWidget *

The image for this dialog.

Flags: Read / Write

Since 2.10

### The `“message-area”` property

      “message-area”             GtkWidget *

The GtkVBox that corresponds to the message area of this dialog. See `gtk_message_dialog_get_message_area()` for a detailed description of this area.

Flags: Read

Since 2.22

### The `“message-type”` property

      “message-type”             GtkMessageType

The type of the message. The type is used to determine the image that is shown in the dialog, unless the image is explicitly set by the ::image property.

Flags: Read / Write / Construct

Default value: GTK_MESSAGE_INFO

### The `“secondary-text”` property

      “secondary-text”           gchar *

The secondary text of the message dialog.

Flags: Read / Write

Default value: NULL

Since 2.10

### The `“secondary-use-markup”` property

      “secondary-use-markup”     gboolean

`TRUE` if the secondary text of the dialog includes Pango markup. See `pango_parse_markup()`.

Flags: Read / Write

Default value: FALSE

Since 2.10

### The `“text”` property

      “text”                     gchar *

The primary text of the message dialog. If the dialog has a secondary text, this will appear as the title.

Flags: Read / Write

Default value: ""

Since 2.10

### The `“use-markup”` property

      “use-markup”               gboolean

`TRUE` if the primary text of the dialog includes Pango markup. See `pango_parse_markup()`.

Flags: Read / Write

Default value: FALSE

Since 2.10

## Style Property Details

### The `“message-border”` style property

      “message-border”           gint

Width of border around the label and image in the message dialog.

Flags: Read

Allowed values: >= 0

Default value: 12

### The `“use-separator”` style property

      “use-separator”            gboolean

Whether to draw a separator line between the message label and the buttons in the dialog.

`GtkMessageDialog:use-separator` has been deprecated since version 2.22 and should not be used in newly-written code.

This style property will be removed in GTK+ 3

Flags: Read

Default value: FALSE

Since 2.4

## See Also

GtkDialog